# Contributing to Pedestal

Wow, thanks for your interest in helping out with Pedestal. Let this document
serve as your guide.

### Looking for work?

If you're looking for a task to work on, check out the
[primed label](../../issues?labels=primed) in our issues.

Less defined tasks will be marked with the
[discuss label](../../issues?labels=discuss). Jump in here if you want to be
a part of something big.

### New Features

Pedestal is the thinking persons framework, so every contribution starts with
some *deeeep* thought. Finished?

Alright, your next step is to start a discussion.

Create an [issue](https://github.com/pedestal/pedestal/issues/new) to start
a conversation. Tell us what you're trying to accomplish and how you think you
might do it. If all is well, we'll probably give you the :thumbsup: to
start developing.

### Bugs

Of course, if you run into any straight-up bugs or weirdness feel free to skip
the thinking (or at least too much of it) and immediately submit an
[issue](https://github.com/pedestal/pedestal/issues/new).

At minimum include details about the platform you are running and steps to
reproduce--you know we're going to ask. A good starting point is the following:

* Operating System (including version).
    * e.g. "OS X 10.8"
* Your current Leiningen version (`lein --version`)
    * e.g. "Leiningen 2.0.0 on Java 1.6.0_45 Java HotSpot(TM) 64-Bit Server VM"
* Pedestal version
    * e.g. "0.1.6"
    * or, for a SNAPSHOT: "0.1.6-SNAPSHOT at 57d4911"
* Steps to reproduce:
    * e.g. "When you create a new pedestal app, and do X, Y and Z you will
      see this error: ..."

Even better, include a link to a gist or repository where we can jump straight
to the problem.

### Tests

We love well-tested code. All of our code is tested on [Travis
CI](https://travis-ci.org/pedestal/pedestal) and so too will any pull requests
you submit. It's super-cool and automatic!

But lets be serious, we won't accept pull requests unless they're either well
tested or sufficiently trivial (think docstring changes).

## Contributor's Agreement

When it comes to code contributions there is one more thing we need from
you: a signed contributor's agreement.

We know that a contributor's agreement can be a pain, but we want everyone
to be able to use Pedestal, including developers working on projects for very
large companies. Many of these big organizations care *a lot* about the provenance of
the code they use -- that is they need to know where the code came from and who owns it.
The contributor's agreement simply puts down in writing what we think is the
standard open source arrangement: Mostly it says that you are donating code that
you wrote to the project. By submitting a signed contributor's agreement,
you are helping to ensure that your work will be available to the largest possible audience.

It is an extra step, but there really is not much to executing the Pedestal contributor's agreement: You just need to send a copy of the CA with your signature
(and a few other details) to [contribute@pedestal.io](mailto:contribute@pedestal.io).

You can find the [CA form](cognitect-ca.pdf) in the repo.

