# Contribution Guidelines

Thanks for your interest in contributing to Pedestal documentation!

The pedestal/docs repository follows similar (but slightly different!) guidelines to our other repositories; new content and substantial changes still require a signed Contributor Agreement (CA), while typos and other minor changes do not.

Visit our [contribution page](http://pedestal.io/#contribute) for more information on the CA process and how to submit your own signed CA.

## Submissions

In general, we appreciate any and all submissions, but please remember Pedestal is very much a work in progress; we may make changes that invalidate certain submissions.

### Major changes

We'd like to ask that anyone considering putting forth a substantial effort towards Pedestal documentation start that effort with a conversation. Open an [issue](https://github.com/pedestal/docs/issues) or send a message to 
the [pedestal-dev](https://groups.google.com/d/forum/pedestal-dev) list and let us know what you're working on.

While working on documentation we encourage you to ping Relevancers frequently for feedback; we're more than happy to help you write awesome documentation for our baby.

All substantial pull requests will required a signed [CA](http://pedestal.io/#contribute).

**Note**: We can tell you already [app](github.com/pedestal/pedestal/app) is undergoing major changes (2013-04-19). You're welcome to help document `app`, but please just wait a few more weeks :wink:.

### Typos and other minor changes

You are welcome to open pull requests for small changes like typo correction or grammar fixes without prior conversation.

We will generally accept these pull requests **without** a signed CA on file.
